<?php

namespace Modules\User\Models;

use App\Models\ForcedPassword;
use Laravel\Sanctum\HasApiTokens;
use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\HasManyThrough;
use Illuminate\Database\Eloquent\Factories\HasFactory;

use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable, ForcedPassword;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'normalized_name',
        'phone',
        'normalized_phone',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password'          => 'hashed',
    ];

    #[SearchUsingFullText(['name', 'phone', 'email'])]
    public function toSearchableArray()
    {
        return [
            'name' => $this->name,
            'phone' => $this->price,
            'email' => $this->email,
        ];
    }
    public function getPartialsName()
    {
        $name = explode(' ', $this->name);
        return [
            'firstName'  => (array_key_exists(0, $name) ? $name[0] : ''),
            'secondName' => (array_key_exists(1, $name) ? $name[1] : ''),
            'familyName' => (array_key_exists(2, $name) ? $name[2] : '')
        ];
    }
    /**
     * Функция проверят наличие роли у пользователя
     * @param mixed $roleId - лучше брать из констант модели Modules\User\Models\Role
     * @return bool
     */
    public function hasRole($roleId)
    {
        $roles = $this->roles()->get();
        if ($roles->where('id', $roleId)->count()) {
            return true;
        }
        return false;
    }

    public function isCompanyAdmin()
    {
        return $this->hasRole(Role::COMPANY_ADMIN);
    }
    public function isAdmin()
    {
        return $this->hasRole(Role::SUPER_ADMIN);
    }

    public function isCityManager()
    {
        return $this->hasRole(Role::CITY_MANAGER);
    }

    public function roles(): HasManyThrough
    {
        return $this->hasManyThrough(
            Role::class,
            UserRole::class,
            'user_id',
            'id',
            'id',
            'role_id'

        );
    }

    protected static function booted()
    {
        static::creating(function (User $user) {
            $user->normalized_name = mb_strtolower($user->name);
            $user->normalized_phone = str_replace('+7', '8', $user->phone);
            $user->normalized_phone = str_replace([' ', '-', '+', '(', ')'], '', $user->normalized_phone);
            $user->normalized_phone = preg_replace("/[^0-9]/", "", $user->normalized_phone);
        });

        static::deleted(function (User $user) {
            foreach ($userRoles = UserRole::where('user_id', $user->id)->get() as $userRole) {
                $userRole->delete();
            }
        });
    }
}
